"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var FocusTrapZone_1 = require("office-ui-fabric-react/lib/FocusTrapZone");
var Link_1 = require("office-ui-fabric-react/lib/Link");
var TextField_1 = require("office-ui-fabric-react/lib/TextField");
var Toggle_1 = require("office-ui-fabric-react/lib/Toggle");
var Stack_1 = require("office-ui-fabric-react/lib/Stack");
var _focusClassName = 'shouldFocusInput';
var FocusTrapZoneBoxCustomElementExample = /** @class */ (function (_super) {
    tslib_1.__extends(FocusTrapZoneBoxCustomElementExample, _super);
    function FocusTrapZoneBoxCustomElementExample() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            useTrapZone: false
        };
        _this._toggle = React.createRef();
        _this._onFocusTrapZoneToggleChanged = function (ev, checked) {
            _this.setState({ useTrapZone: !!checked }, function () {
                // Restore focus to toggle after disabling the trap zone
                // (the trap zone itself will handle initial focus when it's enabled)
                if (!checked) {
                    _this._toggle.current.focus();
                }
            });
        };
        return _this;
    }
    FocusTrapZoneBoxCustomElementExample.prototype.render = function () {
        return (React.createElement("div", null, this.state.useTrapZone ? (React.createElement(FocusTrapZone_1.FocusTrapZone, { firstFocusableSelector: _focusClassName }, this._internalContents())) : (this._internalContents())));
    };
    FocusTrapZoneBoxCustomElementExample.prototype._internalContents = function () {
        var useTrapZone = this.state.useTrapZone;
        return (React.createElement(Stack_1.Stack, { horizontalAlign: "start", tokens: { childrenGap: 15 }, styles: {
                root: { border: "2px solid " + (useTrapZone ? '#ababab' : 'transparent'), padding: 10 }
            } },
            React.createElement(Toggle_1.Toggle, { label: "Use trap zone", componentRef: this._toggle, checked: useTrapZone, onChange: this._onFocusTrapZoneToggleChanged, onText: "On (toggle to exit)", offText: "Off" }),
            React.createElement(TextField_1.TextField, { label: "Input inside trap zone", styles: { root: { width: 300 } } }),
            React.createElement(Link_1.Link, { href: "https://bing.com", className: _focusClassName }, "Hyperlink which will receive initial focus when trap zone is activated")));
    };
    return FocusTrapZoneBoxCustomElementExample;
}(React.Component));
exports.FocusTrapZoneBoxCustomElementExample = FocusTrapZoneBoxCustomElementExample;
//# sourceMappingURL=FocusTrapZone.Box.FocusOnCustomElement.Example.js.map