import * as tslib_1 from "tslib";
import * as React from 'react';
import { FocusTrapZone } from 'office-ui-fabric-react/lib/FocusTrapZone';
import { TextField } from 'office-ui-fabric-react/lib/TextField';
import { Toggle } from 'office-ui-fabric-react/lib/Toggle';
import { Stack } from 'office-ui-fabric-react/lib/Stack';
var FocusTrapZoneNoTabbableExample = /** @class */ (function (_super) {
    tslib_1.__extends(FocusTrapZoneNoTabbableExample, _super);
    function FocusTrapZoneNoTabbableExample() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { useTrapZone: false };
        _this._toggle = React.createRef();
        _this._onFocusTrapZoneToggleChanged = function (ev, checked) {
            _this.setState({ useTrapZone: !!checked }, function () {
                // Restore focus to toggle after disabling the trap zone
                // (the trap zone itself will handle initial focus when it's enabled)
                if (!checked) {
                    _this._toggle.current.focus();
                }
            });
        };
        return _this;
    }
    FocusTrapZoneNoTabbableExample.prototype.render = function () {
        return (React.createElement("div", null, this.state.useTrapZone ? (React.createElement(FocusTrapZone, { forceFocusInsideTrap: true, focusPreviouslyFocusedInnerElement: true }, this._internalContents())) : (this._internalContents())));
    };
    FocusTrapZoneNoTabbableExample.prototype._internalContents = function () {
        var useTrapZone = this.state.useTrapZone;
        return (React.createElement(Stack, { horizontalAlign: "start", tokens: { childrenGap: 15 }, styles: {
                root: { border: "2px solid " + (useTrapZone ? '#ababab' : 'transparent'), padding: 10 }
            } },
            React.createElement(Toggle, { label: "Use trap zone", componentRef: this._toggle, checked: useTrapZone, onChange: this._onFocusTrapZoneToggleChanged, onText: "On (toggle to exit)", offText: "Off" }),
            React.createElement(TextField, { placeholder: "Not tabbable", tabIndex: -1 }),
            React.createElement(TextField, { placeholder: "Not tabbable", tabIndex: -1 }),
            React.createElement(TextField, { placeholder: "Not tabbable", tabIndex: -1 })));
    };
    return FocusTrapZoneNoTabbableExample;
}(React.Component));
export { FocusTrapZoneNoTabbableExample };
//# sourceMappingURL=FocusTrapZone.NoTabbable.Example.js.map